part of masamune.flutter;

class PathProvider<T extends IPath> extends AlwaysAliveProviderBase<T, T> {
  PathProvider(Create<T, ProviderReference> create) : super(create, null);

  @override
  _PathProviderState<T> createState() => _PathProviderState();
}

@sealed
class _PathProviderState<T extends IPath> = ProviderStateBase<T, T>
    with _PathProviderStateMixin<T>;

mixin _PathProviderStateMixin<T extends IPath> on ProviderStateBase<T, T> {
  @override
  void valueChanged({T previous}) {
    if (createdValue == previous) {
      return;
    }
    previous?.unwatch(_listener);
    exposedValue = createdValue;
    createdValue?.watch(_listener);
  }

  void _listener(T path) {
    exposedValue = createdValue;
  }

  @override
  void dispose() {
    createdValue?.unwatch(_listener);
    super.dispose();
  }
}
